#include <stdio.h>
#include <stdlib.h>

int p = 0;

void fill4(long int n, long int m, long long int arr[n][m], long int x, long int y, long long int fillcolor)
{
    if(x < n && x >= 0 && y < m && y >= 0)
    {
        //printf("asd");
       if(arr[x][y] == 0)
        {
            if(p == 0)
            {
                p = 1;
            }
            arr[x][y] = fillcolor;
            fill4(n,m,arr,x+1,y,fillcolor);
            fill4(n,m,arr,x-1,y,fillcolor);
            fill4(n,m,arr,x,y+1,fillcolor);
            fill4(n,m,arr,x,y-1,fillcolor);

        }
    }


}

int main()
{
    long int n,m;
    long int k;
    long int x,y;
    long long int c = 2;
    scanf("%li %li %li", &n, &m, &k);
    long long int arr[n][m];

    for(long int j=0; j<m; j++)
    {
        for(long int i=0; i<n; i++)
        {
            arr[i][j] = 0;
        }
    }

    for(long long int i=0; i<k; i++)
    {
        scanf("%li %li", &x, &y);
        arr[x-1][y-1] = 1;
    }
    for(long int j=0; j<m; j++)
    {
        for(long int i=0; i<n; i++)
        {
            if(p == 0)
            {
                fill4(n,m,arr,i,j,c);
            }
            else if(p == 1)
            {
                p = 0;
                fill4(n,m,arr,i,j,c++);
            }

        }
    }
    printf("%lli\n",c-1);
    return 0;
}